package shooting1;
import java.awt.*;
import java.awt.event.*;

/**
* Bullet Class<p>
* Movement, draw methods
*/
public class Bullet extends GameObject
{
	double direction;
	double speed;
	double speedX;
	double speedY;
	
	/**
	 * Constructor
	 */
	Bullet()
	{
		//Initialization(False)
		active = false;
	}
	
	/**
	 * Movement declaration.Called once for each main loop.
	 */
	public void move()
	{
		x += speedX;
		y += speedY;
		
		if ( (x < 0)||(500 < x)||(y < 0)||(500 < y) )
		{
			active = false;
		}
	}
	
	/**
	 * draw method
	 * called once for each main loop.
	 * @param g graphic handler
	 */
	public void draw(Graphics g)
	{
		g.setColor(Color.blue);
		g.drawRect((int)(x-3), (int)(y-3), (int)6, (int)6);
	}
	
	/**
	 * activate the instance.
	 * initialization is done here too.
	 * @param ix x coordinate where the object is produced
	 * @param iy y coordinate where the object is produced
	 * @param idirection direction in degrees(0~360)
	 * @param ispeed speed in pixels
	 */
	public void activate(double ix, double iy, double idirection, double ispeed)
	{
		x = ix;
		y = iy;
		direction = idirection;
		speed = ispeed;
		active = true;			//Activate the bullet instance
		
		
		//Convert polar coordinate(speed & direction) to x-y speed for better performance
		double radian;
		radian = Math.toRadians(direction);	//Convert degree to radiant
		speedX = speed * Math.cos(radian);
		speedY = speed * Math.sin(radian);
	}

	/**
	 * Radiant fire
	 */
	public static void FireRound(double x, double y)
	{
		for (int i = 0; i < 360; i += 60 )
		{
			ObjectPool.newBullet(x, y, i, 3);
		}
	}

	//Lock on player
	public static void FireAim(double x, double y, Player player)
	{
		double degree = Math.toDegrees(Math.atan2(player.y - y, player.x - x));
		ObjectPool.newBullet(x, y, degree, 4);
		ObjectPool.newBullet(x, y, degree+20, 4);
		ObjectPool.newBullet(x, y, degree-20, 4);
	}
}

