package shooting1;
import java.awt.*;
import java.awt.event.*;
import java.util.Random;

/**
*Enemy Class<p>
*Movement, draw methods
*/
public class Enemy extends GameObject
{
	//Enemy life time
	int counter = 0;
	//Hit point
	int hitpoint;
	//Types of Enemy
	int type;
	//ishit Flag
	boolean ishit = false;
	//Reference to player instance
	Player player;
	//startshoot flag
	boolean startshoot;
	int shootnum;

	/**
	 * Constructor
	 * @param Pass the player's instance, for recognizing player's location.
	 */
	Enemy(Player iplayer)
	{
		//Detect player
		player = iplayer;
		//Initialization(False)
		active = false;
	}

	/**
	 * activate the instance.
	 * initialization is done here too.
	 * @param ix x coordinate where the object is produced
	 * @param iy y coordinate where the object is produced
	 */
	public void activate(double ix, double iy)
	{
		x = ix;
		y = iy;
		type = (int)(Math.random()+0.5);
		active = true;			//Activate the bullet instance
		hitpoint = Level.getLevel()*10; //increases enemy hitpoints with level
		counter = 0;
		boolean ishit = false;
		shootnum = Level.getLevel(); //increases the number of bullets with a new level
		startshoot = false;
	}

	/**
	 * Behavior of enemy when it is hit by player's bullet
	 */
	public void hit()
	{
		//Decrease hitpoint
		hitpoint--;
		ishit = true;
		if (hitpoint < 0)
		{
			//Score depends on enemy kind
			switch(type)
			{
				case 0:
					Score.addScore(10);
					break;
				case 1:
					Score.addScore(20);
					break;
				default:
			}
			//Add to Score

			//Produce explotion particle
			ObjectPool.newParticle(x, y, 45, 2);
			ObjectPool.newParticle(x, y, 135, 2);
			ObjectPool.newParticle(x, y, 225, 2);
			ObjectPool.newParticle(x, y, 315, 2);
			active = false;
		}
	}
	
	/**
	 * 
	 */
	public void move()
	{
		//Differentiate by enemy kinds
		switch(type)
		{
			case 0:
				move_enemy0();
				break;
			case 1:
				move_enemy1();
				break;
			default:
		}
	}
	
	/**
	 * Enemy1 movement
	 */
	void move_enemy0()
	{
		counter++;
		y++;
		//Sin wave move
		x += Math.sin(y / 20);
		
		//Deactivate instance when it is out of screen.
		if ( (500 < y) )
		{
			active = false;
		}
		
		//Shoot frequency
		if ((counter%80)==0)
		{
			Bullet.FireRound(x, y);
		}
	}

	/**
	 * Enemy2 movement
	 */
	/*void move_enemy1()
	{
		counter++;
		double p = 60;	//Time until stabilize
		double q = 200;	//Stabilize position
		//Quadratic Formula for movement pattern
		y = (-q / Math.pow(p,2) * Math.pow((counter - p), 2) + q);

		//Deactivate when it is out of screen
		if ( (-30 > y) )
		{
			active = false;
		}
		
		//Shoot frequency
		if ((counter%60)==0)
		{
			//Active startshoot flag
			startshoot = true;
		}
		
		//Number of bullets depends on current level.
		if (startshoot)
		{
			if (((counter%5)==0)&&(shootnum>0))
			{
				Bullet.FireAim(x, y, player);
				shootnum--;
			}
		}
	}*/
	
	void move_enemy1()
	{
		counter++;	
		int count;
		Random random = new Random();
		if(counter % 30 == 0)
		{
			x+=random.nextInt(100);
			y+=+random.nextInt(250);
		}
		
			
		
		

		//Deactivate when it is out of screen
		if ( (-30 > y) )
		{
			active = false;
		}
		
		//Shoot frequency
		if ((counter%60)==0)
		{
			//Active startshoot flag
			startshoot = true;
		}
		
		//Number of bullets depends on current level.
		if (startshoot)
		{
			if (((counter%5)==0)&&(shootnum>0))
			{
				Bullet.FireAim(x, y, player);
				shootnum--;
			}
		}
	}
	
	/**
	 * Draw method
	 * Called for each main loop.
	 * @param g graphic handler
	 */
	public void draw(Graphics g)
	{
		//Color change when enemy is hit(Orange)
		if (ishit)
		{
			g.setColor(Color.orange);
		}else{
			switch(type)
			{
				case 0:
					g.setColor(Color.pink);
					break;
				case 1:
					g.setColor(Color.white);
					break;
				case 3:
					g.setColor(Color.green);
				default:
			}
		}
		ishit = false;
		g.drawRect((int)x-16, (int)y-16, (int)32, (int)32);
	}
	

}

