package shooting1;
import java.awt.*;
import java.awt.event.*;

/**
*KeyInput Class<p>
*controls the key inputs
*space to shoot<p>
*arrows to move
*/
public class KeyInput extends KeyAdapter
{
	//fields to hold the state of keyboard
	boolean keyup;
	boolean keydown;
	boolean keyleft;
	boolean keyright;
	
	/**
	 * three states
	 * 0:not pressed
	 * 1:pressed
	 * 2:pressed and released
	 */
	int keyshot;

	KeyInput() {
		keyup = false;
		keydown = false;
		keyleft = false;
		keyright = false;
		keyshot = 0;
	}

	/**
	 * L?[ꂽƂɌĂ΂???B
	 * ?ɃL?[?Ԃۑ?B
	 */
	public void keyPressed(KeyEvent e) {
		int keycode = e.getKeyCode();
		if (keycode == KeyEvent.VK_LEFT)
		{
			keyleft = true;
		}
		if (keycode == KeyEvent.VK_RIGHT)
		{
			keyright = true;
		}
		if (keycode == KeyEvent.VK_UP)
		{
			keyup = true;
		}
		if (keycode == KeyEvent.VK_DOWN)
		{
			keydown = true;
		}
		if (keycode == KeyEvent.VK_SPACE)
		{
			//first pressed
			if (keyshot == 0)
			{
				//flag for the instant that the key is pressed
				keyshot = 2;
			}
			else
			{
				//when the key is being pressed and not released
				keyshot = 1;
			}
		}
		
		if (keycode == KeyEvent.VK_ESCAPE)
		{
			System.exit(0);
		}
	}
	
	/**
	 * when the key is released
	 */
	public void keyReleased(KeyEvent e) {
		int keycode = e.getKeyCode();
		if (keycode == KeyEvent.VK_LEFT)
		{
			keyleft = false;
		}
		if (keycode == KeyEvent.VK_RIGHT)
		{
			keyright = false;
		}
		if (keycode == KeyEvent.VK_UP)
		{
			keyup = false;
		}
		if (keycode == KeyEvent.VK_DOWN)
		{
			keydown = false;
		}
		if (keycode == KeyEvent.VK_SPACE)
		{
			keyshot = 0;
		}
	}
	
	/**
	 * get x coordinate
	 * @return -1:right?@0:none?@1:left
	 */
	public int getXDirection()
	{
		int ret = 0;	//stabilized
		if (keyright)
		{
			ret = 1;
		}
		if (keyleft)
		{
			ret = -1;
		}
		return ret;
	}
	
	/**
	 * get y coordinate
	 * @return -1:up?@0:none?@1:down
	 */
	public int getYDirection()
	{
		int ret = 0;	//stabilized
		if (keydown)
		{
			ret = 1;
		}
		if (keyup)
		{
			ret = -1;
		}
		return ret;
	}
	
	/**
	 * Shoot button
	 * @return 0:not pressed 1:is pressed 2:pressed and released
	 */
	public int checkShotKey()
	{
		int ret = keyshot;
		if (keyshot==2)
		{
			keyshot = 1;
		}
		return ret;
	}


}
