package shooting1;
import java.awt.*;
import java.awt.event.*;

/**
 * Player class
 * Movement, draw method

*/
public class Player extends GameObject
{
    double speed;
    
	/**
	 * Constructor
	 * @param ix x coordinate
	 * @param iy y coordinate
	 * @param ispeed speed
	 */
    Player(double ix, double iy, double ispeed)
    {
        x = ix;
		y = iy;
		speed = ispeed;
		active = false;
	}

    /**
     * Dummy function<p>
     * (Required since argument is different from the superclass' abstract method)
     */
    public void move()
    {
    }
	
	/**
	 * Movement
	 * @param mx x direction input(-1 ... +1)
	 * @param my y direction input(-1 ... +1)
	 */
	public void move(int mx, int my)
	{
		//Limit the movement within the canvas
		double postX = x + mx * speed;
		double postY = y + my * speed;
		
		if ((0 < postX)&&(postX < 500))
		{
			x = postX;
		}
		if ((0 < postY)&&(postY < 480))
		{
			y = postY;
		}
	}
	
	//draw method
	public void draw(Graphics g)
	{
		if (active)
		{
			g.setColor(Color.red);
			//draw triangle
			//*Important
			//	-This part should be replaced with drawImage method
			//	-A graphic loader is required
			g.drawLine((int)(x), (int)(y-14), (int)(x-10), (int)(y+7));
			g.drawLine((int)(x), (int)(y-14), (int)(x+10), (int)(y+7));
			g.drawLine((int)(x-10), (int)(y+7), (int)(x+10), (int)(y+7));
		}
	}
	
	
}
